summaryrefslogtreecommitdiffstats
path: root/source/l/libgphoto2/libgphoto2.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'source/l/libgphoto2/libgphoto2.SlackBuild')
-rwxr-xr-xsource/l/libgphoto2/libgphoto2.SlackBuild144
1 files changed, 144 insertions, 0 deletions
diff --git a/source/l/libgphoto2/libgphoto2.SlackBuild b/source/l/libgphoto2/libgphoto2.SlackBuild
new file mode 100755
index 000000000..fec05df70
--- /dev/null
+++ b/source/l/libgphoto2/libgphoto2.SlackBuild
@@ -0,0 +1,144 @@
+#!/bin/sh
+
+# Copyright 2007-2008 Frank Caraballo <fecaraballo{at}gmail{dot}com>
+# Copyright 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+PRGNAM=libgphoto2
+VERSION=2.4.6
+ARCH=${ARCH:-x86_64}
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PRGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z* || exit 1
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --disable-static \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --with-doc-dir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux
+
+make $NUMJOBS || make || exit 1
+
+# Make sure udev helper scripts are put in the right place and
+# install the other utilities to /usr/bin instead of /usr/lib/libgphoto2/
+make $NUMJOBS \
+ udevscriptdir=/lib/udev \
+ utilsdir=/usr/bin \
+ || make \
+ udevscriptdir=/lib/udev \
+ utilsdir=/usr/bin \
+ || exit 1
+make \
+ udevscriptdir=/lib/udev \
+ utilsdir=/usr/bin \
+ install DESTDIR=$PKG || exit 1
+
+# Strip binaries:
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+# Generate udev rules and hal device information files
+# First, we'll have to set (and export) some important variables
+LD_LIBRARY_PATH=$PKG/usr/lib${LIBDIRSUFFIX}
+CAMLIBS=$PKG/usr/lib${LIBDIRSUFFIX}/$PRGNAM/$VERSION
+LIBDIR=$PKG/usr/lib${LIBDIRSUFFIX}
+export LD_LIBRARY_PATH CAMLIBS LIBDIR
+# Generate udev rules
+mkdir -p $PKG/lib/udev/rules.d
+$PKG/usr/bin/print-camera-list udev-rules mode 0660 owner root group plugdev \
+ > $PKG/lib/udev/rules.d/90-libgphoto2.rules
+# Generate fdi files
+mkdir -p $PKG/usr/share/hal/fdi/information/20thirdparty
+$PKG/usr/bin/print-camera-list hal-fdi \
+ > $PKG/usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2.fdi
+$PKG/usr/bin/print-camera-list hal-fdi-device \
+ > $PKG/usr/share/hal/fdi/information/20thirdparty/10-camera-libgphoto2-device.fdi
+unset LD_LIBRARY_PATH CAMLIBS LIBDIR # Unset these just in case
+
+# Compress man pages
+( cd $PKG/usr/man
+ find . -type f -exec gzip -9 {} \;
+ for i in $(find . -type l) ; do ln -s $(readlink $i).gz $i.gz ; rm $i ; done
+)
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING* HACKING INSTALL MAINTAINERS \
+ NEWS README* TESTERS \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+# The entire ChangeLog is excessive for most users:
+cat $PKG/usr/doc/$PRGNAM-$VERSION/ChangeLog | head -n 1000 > $PKG/usr/doc/$PRGNAM-$VERSION/CL
+mv $PKG/usr/doc/$PRGNAM-$VERSION/CL $PKG/usr/doc/$PRGNAM-$VERSION/ChangeLog
+# The apidocs are huge, and probably only of interest to developers who will
+# very likely use the source code as a reference:
+rm -r $PKG/usr/doc/$PRGNAM-$VERSION/apidocs.html
+cat << EOF > $PKG/usr/doc/$PRGNAM-$VERSION/apidocs.html/README
+The complete API documentation may be found in the
+libgphoto2 source code archive.
+EOF
+
+# This library is not built, but it is useful for users to know why that is:
+cp -a camlibs/jl2005a/README.jl2005a $PKG/usr/doc/$PRGNAM-$VERSION/camlibs
+chmod 644 $PKG/usr/doc/$PRGNAM-$VERSION/camlibs/README.jl2005a
+chown root:root $PKG/usr/doc/$PRGNAM-$VERSION/camlibs/README.jl2005a
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.txz
+